]> git.xonotic.org Git - xonotic/xonotic.git/blobdiff - misc/tools/xonotic-map-compiler-autobuild
Make the Xonotic maps no longer exempt of the sRGB requirement, now that all fulfill...
[xonotic/xonotic.git] / misc / tools / xonotic-map-compiler-autobuild
index fec3e114585ed2a6ca104e12dd57e54a3aa06879..bbcedec0ddbc6a2db0fb9056a28b3a75d488ce6f 100755 (executable)
@@ -3,28 +3,38 @@
 set -e
 
 bspdir="$PWD/data"
-url=http://beta.xonotic.org/autobuild-bsp/
+url_http=http://beta.xonotic.org/autobuild-bsp/
 url_ssh=xonotic-beta:autobuild-bsp/
 build_cachedir="$HOME/xonotic-map-compiler.cache/"
 screenshot_cachedir="$HOME/xonotic-map-screenshot.cache/"
-build_override="-bsp_timeout 900 -vis_timeout 3600 -light_timeout 14400 -minimap_timeout 900 -scale_timeout 900"
-screenshot_override="9 300"
+build_override="-bsp_timeout 3600 -vis_timeout 10800 -light_timeout 18000 -minimap_timeout 900 -scale_timeout 900 -timeout_stealing 0.8"
+screenshot_override="9 900 5 +g_ctf 1"
 
 getthemap_fail=false
 
 allmaps()
 {
-       for F in maps/*.map.options; do
-               if ! [ -f "$F" ]; then
-                       continue
-               fi
-               if ! [ -f "${F%.options}" ]; then
-                       continue
-               fi
-               M=${F#maps/}
-               M=${M%.map.options}
-               blobhash=`git ls-files -s -- "$F" | cut -d ' ' -f 2`-`git ls-files -s -- "${F%.options}" | cut -d ' ' -f 2`
-               "$@" "$M" "$blobhash"
+       commithash=$1
+       shift
+       for F in `git show "${commithash}:maps/"`; do
+               case "$F" in
+                       *.map.options)
+                               ;;
+                       *)
+                               continue
+                               ;;
+               esac
+               M=${F%.map.options}
+               blobhash=`git rev-parse --revs-only "${commithash}:maps/$M.map.options" || true`-`git rev-parse --revs-only "${commithash}:maps/$M.map" || true`
+               case "$blobhash" in
+                       -*)
+                               ;;
+                       *-)
+                               ;;
+                       *)
+                               "$@" "$M" "$blobhash" "$commithash"
+                               ;;
+               esac
        done
 }
 
@@ -106,6 +116,11 @@ log2spam()
                        WARNING:\ Couldn\'t\ find\ image\ for\ shader\ *)
                                s_failshaders="$s_failshaders ${L##* }"
                                ;;
+                       ERROR:\ *)
+                               if [ -z "$s_error" ]; then
+                                       s_error=$L
+                               fi
+                               ;;
                        '******* leaked *******')
                                s_leaked=1
                                ;;
@@ -144,26 +159,61 @@ log2spam()
 buildthemap()
 {
        REFNAME=$1
-       HASH=$2
-       url=$3
-       M=$4
-       blobhash=$5
-       if HEAD "$url$M-$blobhash.pk3"; then
+       url=$2
+       M=$3
+       blobhash=$4
+       commithash=$5
+       if lwp-request -m HEAD "$url$M-$blobhash.pk3"; then
                continue
        fi
+
+       git reset --hard
+       git clean -xfd
+       git checkout -f "$commithash"
+
        if [ -n "$IRCSPAM" ]; then
-               pre2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$HASH" | $IRCSPAM
+               pre2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$commithash" | $IRCSPAM || true
        fi
+
        t0=`date +%s`
-       (
-               cd maps
-               ../../../misc/tools/xonotic-map-compiler "$M" `grep ^- "$M.map.options" | cut -d '#' -f 1` $build_override > "$M.log"
+
+       # It's sad that we must enforce this rule by code.
+       if grep -- '-nosRGB' "maps/$M.map.options" >/dev/null; then
+               is_nosrgb=true
+       else
+               is_nosrgb=false
+       fi
+       allow_build=true
+       if $is_nosrgb; then
+               case "$REFNAME" in
+                       master|refs/heads/master|origin/master|refs/remotes/origin/master)
+                               if [ -n "$IRCSPAM" ]; then
+                                       echo "\ 34ERROR: map $M uses -nosRGB. This is not acceptable in master. Please fix." | $IRCSPAM || true
+                               fi
+                               allow_build=false
+                               ;;
+                       *)
+                               if [ -n "$IRCSPAM" ]; then
+                                       echo "\ 34WARNING:\ f map $M uses -nosRGB. This is not acceptable in master. Please fix." | $IRCSPAM || true
+                               fi
+                               ;;
+               esac
+       fi
+
+       set +e
+       $allow_build && (
+               cd ../..
+               misc/tools/xonotic-map-compiler-optionsfile "data/xonotic-maps.pk3dir/maps/$M" $build_override > "data/xonotic-maps.pk3dir/maps/$M.log" 2>&1
        )
+       status=$?
+       set -e
+       if ! [ -f "maps/$M.bsp" ]; then
+               echo >>"maps/$M.log" "ERROR: No BSP file"
+       fi
        t1=`date +%s`
        dt=$(($t1 - $t0))
-       status=$?
        if [ -n "$IRCSPAM" ]; then
-               cat "maps/$M.log" | log2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$HASH" "$status" "$dt" > "maps/$M.irc"
+               cat "maps/$M.log" | log2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$commithash" "$status" "$dt" > "maps/$M.irc"
        fi
        zip -9r "$M-$blobhash.pk3" "maps/$M.bsp" "maps/$M.log" "maps/$M.irc" "maps/$M/" "maps/$M.lin" "gfx/${M}_mini.tga"
        ln -snf "../$M-$blobhash.pk3" "$M.pk3" # from ALL branches, so beware!
@@ -173,39 +223,67 @@ buildthemap()
        rsync -vaSHP "$M-$blobhash.pk3" "$M-full-$blobhash.pk3" "$url_ssh"
        rsync -vaSHP "$M.pk3" "$M-full.pk3" "$url_ssh""latest/"
        if [ -n "$IRCSPAM" ]; then
-               $IRCSPAM < "maps/$M.irc"
+               $IRCSPAM < "maps/$M.irc" || true
+       fi
+       if [ -n "$BUILD_ONE" ]; then
+               exit
        fi
 }
 
 screenshotthemap()
 {
        REFNAME=$1
-       HASH=$2
-       url=$3
-       M=$4
-       blobhash=$5
-       if HEAD "$url$M-$blobhash/"; then
+       url=$2
+       M=$3
+       blobhash=$4
+       commithash=$5
+       if lwp-request -m HEAD "$url$M-$blobhash/$M-000000.jpg"; then
                continue
        fi
-       rm -rf ~/.xonotic
+
+       if ! unzip -l "$bspdir/$M-$blobhash.pk3" "maps/$M.bsp"; then
+               # no BSP file
+               continue
+       fi
+
+       rm -rf ~/.xonotic/data
+       mkdir -p ~/.xonotic/data
        (
                cd ../..
-               misc/tools/xonotic-map-screenshot "$M" $screenshot_override +"scr_screenshot_name \"$M-\""
-       )
-       if ! mv ~/.xonotic/data/screenshots "$M-$blobhash"; then
-               if [ -n "$IRCSPAM" ]; then
-                       ss2spam "$M" "$url$M-$blobhash/" "$REFNAME" "$HASH" > "maps/$M.ircss"
+               if [ -n "$DISPLAY" ]; then
+                       misc/tools/xonotic-map-screenshot "$M" $screenshot_override $DRIVERFLAGS +"scr_screenshot_name \"$M-\""
+               else
+                       case "$DRIVER" in
+                               gl)
+                                       startx "$PWD/misc/tools/xonotic-map-screenshot" "$M" $screenshot_override $DRIVERFLAGS +"scr_screenshot_name \"$M-\"" -- :8
+                                       ;;
+                               soft|*)
+                                       startx "$PWD/misc/tools/xonotic-map-screenshot" "$M" $screenshot_override +"vid_soft 1" $DRIVERFLAGS +"scr_screenshot_name \"$M-\"" -- /usr/bin/Xvfb :8 -screen 0 1024x768x24
+                                       ;;
+                       esac
                fi
-               return 1
-       fi
-       if [ -n "$IRCSPAM" ]; then
-               ss2spam "$M" "$url$M-$blobhash/" "$REFNAME" "$HASH" > "maps/$M.ircss"
+       ) 2>&1 | tee ~/.xonotic/data/autoscreenshot.log
+       good=false
+       if mv ~/.xonotic/data/screenshots "$M-$blobhash"; then
+               ss2spam "$M" "$url?d" "$REFNAME" "$commithash" 0 > ~/.xonotic/data/"$M.ircss"
+       else
+               mkdir "$M-$blobhash"
+               ss2spam "$M" "$url?d" "$REFNAME" "$commithash" 1 > ~/.xonotic/data/"$M.ircss"
        fi
+       mv ~/.xonotic/data/"$M.ircss" "$M-$blobhash"/
+       mv ~/.xonotic/data/autoscreenshot.log "$M-$blobhash"/
+       chmod 1777 "$M-$blobhash"
        ln -snf "../$M-$blobhash" "$M" # from ALL branches, so beware!
        rsync -vaSHP "$M-$blobhash" "$url_ssh"
        rsync -vaSHP "$M" "$url_ssh""latest/"
        if [ -n "$IRCSPAM" ]; then
-               $IRCSPAM < "maps/$M.ircss"
+               # It takes about 5 minutes for the server to update.
+               sleep 360  # Cut it one more minute of slack.
+
+               $IRCSPAM < "$M-$blobhash/$M.ircss" || true
+       fi
+       if [ -n "$BUILD_ONE" ]; then
+               exit
        fi
 }
 
@@ -216,13 +294,17 @@ getthemap()
        bspdir=$3
        M=$4
        blobhash=$5
+       commithash=$6
        if mv "$bspdir_old/$M-$blobhash.pk3" "$bspdir/$M-$blobhash.pk3"; then
-               continue
+               if unzip -l "$bspdir/$M-$blobhash.pk3" >/dev/null 2>&1; then
+                       return 0
+               fi
        fi
-       if ! wget -O "$bspdir/$M-$blobhash.pk3" "$url$M-$blobhash.pk3"; then
+       if ! wget -c -O "$bspdir/$M-$blobhash.pk3" "$url$M-$blobhash.pk3"; then
                if ! curl -o "$bspdir/$M-$blobhash.pk3" "$url$M-$blobhash.pk3"; then
                        rm -f "$bspdir/$M-$blobhash.pk3"
                        echo "WARNING: could not download $url$M-$blobhash.pk3, maybe not ready yet"
+                       getthemap_fail=true
                        return 0
                fi
        fi
@@ -234,55 +316,99 @@ getthemap()
        fi
 }
 
+indexthemap()
+{
+       REFNAME=$1
+       M=$2
+       blobhash=$3
+       commithash=$4
+       echo "$M $blobhash $commithash $REFNAME"
+}
+
+rundownload()
+{
+       mkdir -p "$bspdir" "$bspdir.old"
+       for b in "$bspdir"/*-????????????????????????????????????????-????????????????????????????????????????.pk3; do
+               if [ -e "$b" ]; then
+                       mv "$b" "$bspdir.old"/
+               fi
+       done
+       allmaps "HEAD" getthemap "$url_http" "$bspdir.old" "$bspdir"
+}
+
+branches()
+{
+       git for-each-ref 'refs/remotes' | grep -vE '    refs/remotes/([^/]*/HEAD|.*/archived/.*)$'
+}
+
+runmakeindex()
+{
+       cd data/xonotic-maps.pk3dir
+       branches | while read -r HASH TYPE REFNAME; do
+               allmaps "$HASH" indexthemap "$REFNAME"
+       done
+       cd ../..
+}
+
 case "$1" in
        build)
                cd data/xonotic-maps.pk3dir
-               git for-each-ref 'refs/remotes' | while read -r HASH TYPE REFNAME; do
+               branches | while read -r HASH TYPE REFNAME; do
                        if [ -f "$build_cachedir/$HASH" ]; then
                                continue
                        fi
-                       git reset --hard
-                       git clean -xfd
-                       git checkout -f "$HASH"
-                       allmaps buildthemap "$REFNAME" "$HASH" "$url"
+                       allmaps "$HASH" buildthemap "$REFNAME" "$url_http"
                        touch "$build_cachedir/$HASH"
                done
                git checkout -f master
                ;;
        screenshot)
+               runmakeindex > "branches.idx.new"
+               rsync -vaSHP "branches.idx.new" "$url_ssh""branches.idx.new"
+               rm -f "branches.idx.new"
                cd data/xonotic-maps.pk3dir
-               git for-each-ref 'refs/remotes' | while read -r HASH TYPE REFNAME; do
+               branches | while read -r HASH TYPE REFNAME; do
                        if [ -f "$screenshot_cachedir/$HASH" ]; then
                                continue
                        fi
+
                        git reset --hard
                        git clean -xfd
                        git checkout -f "$HASH"
-                       allmaps getthemap "$url" "$bspdir.old" "$bspdir"
-                       if ! $getthemap_fail; then
-                               allmaps screenshotthemap "$REFNAME" "$HASH" "$url"
-                               touch "$screenshot_cachedir/$HASH"
+
+                       rundownload
+                       if $getthemap_fail; then
+                               continue
                        fi
+
+                       allmaps "$HASH" screenshotthemap "$REFNAME" "$url_http"
+
+                       touch "$screenshot_cachedir/$HASH"
                done
                git checkout -f master
                ;;
+       makeindex)
+               runmakeindex
+               ;;
        download)
-               mkdir -p "$bspdir" "$bspdir.old"
-               for b in "$bspdir"/*-????????????????????????????????????????-????????????????????????????????????????.pk3; do
-                       if [ -e "$b" ]; then
-                               mv "$b" "$bspdir.old"/
-                       fi
-               done
-               cd data/xonotic-maps.pk3dir
-               allmaps getthemap "$url" "$bspdir.old" "$bspdir"
+               if ! which unzip >/dev/null 2>&1; then
+                       echo "Cannot find unzip, bailing out"
+                       exit 1
+               fi
+               if ! cd data/xonotic-maps.pk3dir >/dev/null 2>&1; then
+                       echo "data/xonotic-maps.pk3dir does not exist, not downloading"
+                       exit 0
+               fi
+               rundownload
+               cd ../..
                echo "List of maps that got deleted (if any) and currently are in $bspdir.old:"
-               ls -l "$bspdir.old"
+               ls -l "$bspdir.old" || true
                ;;
        download-latest)
                mkdir -p "$bspdir"
                cd "$bspdir"
                rm -f *-????????????????????????????????????????-????????????????????????????????????????.pk3
-               wget -r -l1 -A "*.pk3" -N --no-parent --no-directories "$url""latest"
+               wget -r -l1 -A "*.pk3" -N --no-parent --no-directories "$url_http""latest"
                ;;
        log2spam-test)
                log2spam "mapname" "http://mapurl" "branch" "commit" "0"